"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var PriorityQueueIterator = (function () {
    function PriorityQueueIterator(queue) {
        this.index = 0;
        this.stack = [];
        if (queue.heap) {
            this.stack = [queue.heap];
        }
        else {
            this.stack = [];
        }
    }
    PriorityQueueIterator.prototype.hasNext = function () {
        return this.stack.length > 0;
    };
    PriorityQueueIterator.prototype.getNext = function () {
        if (this.hasNext()) {
            var heap = this.stack.pop();
            for (var node = heap.subHeaps; node; node = node.next) {
                this.stack.push(node.head);
            }
            this.index++;
            return heap.entry;
        }
        else {
            throw new Error('Iterator is finished');
        }
    };
    PriorityQueueIterator.prototype.next = function () {
        return this.hasNext() ?
            { value: this.getNext(), done: false } :
            { value: undefined, done: true };
    };
    return PriorityQueueIterator;
}());
exports.PriorityQueueIterator = PriorityQueueIterator;
//# sourceMappingURL=PriorityQueueIterator.js.map